#include <stdio.h>

/* potenciranje: vraca x^n */
/* radi samo za nenegativne potencije */
double pot(double x, int n)
{
    double pot = 1.0;
    while (n > 0)
    {
        pot *= x;
        n--;
    }
    return pot;
}

/* provjerava sadrzi li x u bazi b sve znamenke od 0 do b-1 tocno jednom */
/* rjesenje s nizovima */

/* BITNA NAPOMENA: Ovo rjesenje je POGRESNO, jer
     (a) NE RADI za baze b > 100,
     (b) koristi DODATNE NIZOVE, sto je zabranjeno uputom.
   Takvo rjesenje vrijedi 0 bodova!
*/

int sveznamenkast_nizovi(int x, int b)
{
    int znamenke[100] = {0};
    int brZnam = 0;

    while (x > 0)
    {
        /* ako je broj vec imao ovu znamenku, ne moze biti sveznamenkast */
        if (znamenke[x%b])
            return 0;

        znamenke[x%b] = 1;
        brZnam++;
        x /= b;
    }

    /* ako imamo tocno b znamenki, broj je sveznamenkast jer su sve morale biti razlicite */
    return (brZnam == b);
}

/* provjerava sadrzi li x u bazi b sve znamenke od 0 do b-1 tocno jednom */
/* rjesenje bez nizova */
int sveznamenkast(int x, int b)
{
    int br;
    int i, tmp = x;

    for (i = 0; i < b; ++i)
    {
        x = tmp;
        br = 0;
        while (x > 0)
        {
            if (x%b == i)
                br++;
            if (br > 1) /* znamenka i se pojavljuje vise puta */
                return 0;

            x /= b;
        }
        if (br == 0)
            return 0; /* znamenka i se ne pojavljuje uopce */
    }

    /* ako smo dosli do ovdje, znaci da je broj sveznamenkast */
    return 1;
}

int main()
{
    int b, x;

    scanf("%d", &x);
    int nasao = 0;

    /* najveca baza b za koju ima smisla vrsiti provjeru je ona u kojoj broj ima b znamenki */
    /* moze se uzeti i veca gornja ograda, npr. x, ali ovo je puno brze */
    for (b = 2; x >= pot(b,b-1); ++b)
        if ( sveznamenkast(x, b) )
        {
            nasao = 1;
            break;
        }

    if (nasao)
        printf("Najmanja baza u kojoj je %d sveznamenkast je %d.\n", x, b);
    else
        printf("Ne postoji baza u kojoj je %d sveznamenkast.\n", x);

    return 0;
}
