#include <stdio.h>

/* potenciranje: vraca x^n */
/* radi samo za nenegativne potencije */
double pot(double x, int n)
{
    double pot = 1.0;
    while (n > 0)
    {
        pot *= x;
        n--;
    }
    return pot;
}

/* provjerava sadrzi li x u bazi b sve znamenke od 1 do b-1 barem jednom,
   a nulu proizvoljno mnogo puta */
/* rjesenje s nizovima */

/* BITNA NAPOMENA: Ovo rjesenje je POGRESNO, jer
     (a) NE RADI za baze b > 100,
     (b) koristi DODATNE NIZOVE, sto je zabranjeno uputom.
   Takvo rjesenje vrijedi 0 bodova!
*/

int sveznamenkast_nizovi(int x, int b)
{
    int znamenke[100] = {0};
    int brRazlicitihZnam = 0;

    while (x > 0)
    {
        if (!(x%b)) /* nula nas ne zanima */
        {
            x /= b;
            continue;
        }

        /* ako se ova znamenka prvi put pojavljuje */
        if (!znamenke[x%b])
            brRazlicitihZnam++;

        znamenke[x%b]++;
        x /= b;
    }

    /* ako imamo b-1 razlicitih znamenki, broj je sveznamenkast (nulu ne racunamo) */
    return (brRazlicitihZnam == b-1);
}

/* provjerava sadrzi li x u bazi b sve znamenke od 1 do b-1 barem jednom,
   a nulu proizvoljno mnogo puta */
/* rjesenje bez nizova */
int sveznamenkast(int x, int b)
{
    int br;
    int i, tmp = x;

    for (i = 1; i < b; ++i)
    {
        x = tmp;
        br = 0;
        while (x > 0)
        {
            if (x%b == i)
                br++;
            x /= b;
        }
        if (br == 0) return 0; /* znamenka i se ne pojavljuje uopce */
    }

    /* ako smo dosli do ovdje, znaci da je broj sveznamenkast */
    return 1;
}

int main()
{
    int b, x;

    scanf("%d", &x);
    int nasao = 0;

    /* najveca baza b za koju ima smisla vrsiti provjeru je ona u kojoj broj ima barem b-1 znamenki */
    /* moze se uzeti i veca gornja ograda, npr. x, ali ovo je puno brze */
    for (b = 2; x >= pot(b,b-2); ++b)
        if ( sveznamenkast(x, b) )
            nasao = b;

    if (nasao)
        printf("Najveca baza u kojoj je %d sveznamenkast je %d.\n", x, nasao);
    else
        printf("Ne postoji baza u kojoj je %d sveznamenkast.\n", x);

    return 0;
}
